<template>
  <div>
    <div class="d-flex justify-space-between">
      <div style="width: 100px;">
        <v-select
          v-model="perPage"
          :label="$t('totalVisible')"
          :items="listPerPage"
          @change="getUsuarios"
          dense
        />
      </div>
      <div class="d-flex justify-end">
        <v-btn
          class="mt-2 mr-4"
          color="success"
          rounded
          small
          @click="nuevoUsuario"
          :disabled="loading"
        >
          <v-icon>mdi-table-plus</v-icon>
          {{ $t('nuevoUsuario') }}
        </v-btn>
        <v-btn
          class="mt-2 mr-4"
          color="primary"
          rounded
          small
          @click="refreshTable"
          :disabled="loading"
        >
          <v-icon>mdi-refresh</v-icon>
          {{ $t('actualizar') }}
        </v-btn>
        <v-pagination
          v-model="currentPage"
          :disabled="loading"
          :length="lastPage"
          :total-visible="8"
        />
      </div>
    </div>
    <v-data-table
      v-model="selected"
      :headers="headers"
      :items="UsuarioData"
      item-key="id"
      class="elevation-1"
      disable-pagination
      hide-default-footer
      dense
      :loading="loading"
    >
      <template v-slot:item.actions="{ item }">
        <v-menu
          bottom
          left
        >
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              icon
              v-bind="attrs"
              v-on="on"
            >
              <v-icon>mdi-dots-vertical</v-icon>
            </v-btn>
          </template>
          <v-list dense>
            <v-list-item-group>
              <v-list-item>
                <v-list-item-icon>
                  <v-icon>mdi-pencil</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title @click="editarUsuario(item)">{{ $t('editar') }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item>
              <v-list-item>
                <v-list-item-icon>
                  <v-icon>mdi-delete</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title @click="eliminar(item)">{{ $t('eliminar') }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item>
            </v-list-item-group>
          </v-list>
        </v-menu>
      </template>
    </v-data-table>
  </div>
</template>

<script>
import UsuarioServicio from '@/store/services/UsuarioServicio'

export default {
  name: "UsuariosTabla",
  data() {
    return {
      listPerPage: [5, 10, 20, this.$t('todo')],
      perPage: 20,
      lastPage: 0,
      total: 0,
      currentPage: 1,
      UsuarioData: [],
      selected: [],
      loading: false,
    }
  },
  methods: {
    verifyType(value) {
      return typeof value;
    },
    async getUsuarios() {
      this.loading = true;
      const params = {
        page: this.currentPage,
        order_by: 'created_at',
        order_direction: 'DESC',
        per_page:
          this.verifyType(this.perPage) === 'string'
            ? this.total
            : this.perPage,
      }
      try {
        let response = await UsuarioServicio.index(params)
        this.UsuarioData = response.data.data;
        this.currentPage = response.data.current_page;
        this.lastPage = response.data.last_page;
        this.total = response.data.total;
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          this.$notify({
            group: 'loggedIn',
            type: 'error',
            text: this.$t('errorAlCargar'),
          });
        }
      }
    },
    refreshTable() {
      this.resetCurrentPage();
    },
    resetCurrentPage() {
      if (this.currentPage === 1) this.getUsuarios();
      else this.currentPage = 1;
    },
    nuevoUsuario() {
      this.$emit('onNuevoUsuario');
    },
    editarUsuario(value) {
      this.$emit('onEditarUsuario', value)
    },
    async eliminar(value) {
      try {
        this.loading = true
        await UsuarioServicio.remove(value.id)
        this.refreshTable()
        this.loading = false
      } catch (error) {
        this.loading = false
        console.log(error)
      }
    }
  },
  computed: {
    headers() {
      return [
        {
          value: 'actions',
          sortable: false,
        },
        {
          text: this.$t('nombre'),
          value: 'name',
          sortable: false,
        },
        {
          text: this.$t('correoElectronico'),
          value: 'email',
          sortable: false,
        },
        {
          text: this.$t('area'),
          value: 'area',
          sortable: false,
        },
        {
          text: this.$t('tipo'),
          value: 'tipo',
          sortable: false,
        },
      ];
    },
  },
  watch: {
    currentPage() {
      this.getUsuarios();
    },
  },
  created() {
    this.getUsuarios()
  }
}
</script>

<style>

</style>
